# 2.13.x Release Series

## 2.13.1 (Oct 27, 2022)

The second stable release in the 2.13.x series, with no changes since 2.13.1rc2.

## 2.13.1rc2 (Oct 19, 2022)

### Bug fixes

* Fix remote execution not working with remote caching and eager fetch mode (Cherry-pick of #17272) ([#17274](https://github.com/pantsbuild/pants/pull/17274))

* Adjust `ensure_remote_has_recursive` to succeed if content only exists remotely (Cherry-pick of #17204) ([#17243](https://github.com/pantsbuild/pants/pull/17243))

* fixup name of opt-in flag in error message ([#17038](https://github.com/pantsbuild/pants/pull/17038))

### Documentation

* Add CI talk to resources (Cherry-pick of #17238) ([#17242](https://github.com/pantsbuild/pants/pull/17242))

## 2.13.1rc1 (Oct 07, 2022)

### User API Changes

* Upgrade Pex to 2.1.108. (Cherry-pick of #17112) ([#17123](https://github.com/pantsbuild/pants/pull/17123))

* Upgrade Pex to 2.1.107. (Cherry-pick of #17081) ([#17121](https://github.com/pantsbuild/pants/pull/17121))

* Upgrade Pex to 2.1.103. (Cherry-pick of #16426) ([#17114](https://github.com/pantsbuild/pants/pull/17114))

### Documentation

* Fix spurious linebreaks in the CI docs page. (Cherry-pick of #17154) ([#17156](https://github.com/pantsbuild/pants/pull/17156))

* Add Marcelo to team page, move Josh Reed to Maintainer (Cherry-pick of #16826) ([#17151](https://github.com/pantsbuild/pants/pull/17151))

* Add Doron Somech's proudest contribution (Cherry-pick of #17029) ([#17149](https://github.com/pantsbuild/pants/pull/17149))

* Fix `bsp-groups.toml` example in documentation (Cherry-pick of #17125) ([#17147](https://github.com/pantsbuild/pants/pull/17147))

* Update maintainer job description (Cherry-pick of #17022) ([#17110](https://github.com/pantsbuild/pants/pull/17110))

* Fix the [python-bootstrap].search_path option name in the docs. (Cherry-pick of #17063) ([#17066](https://github.com/pantsbuild/pants/pull/17066))

## 2.13.1rc0 (Sep 29, 2022)

### New Features

* Add retries to NetDownload intrinsic. (Cherry-pick of #16798) ([#16884](https://github.com/pantsbuild/pants/pull/16884))

### Bug fixes

* Add python 3.10 to acceptable GCF runtimes (Cherry-pick of #17028) ([#17054](https://github.com/pantsbuild/pants/pull/17054))

* Fix JVM resources jar file to be deterministic by default (Cherry-pick of #16950) ([#17032](https://github.com/pantsbuild/pants/pull/17032))

* Don't cache VCS version outside the current pants session. (Cherry-pick of #17017) ([#17020](https://github.com/pantsbuild/pants/pull/17020))

* Fix for hang with redirected stdio. (Cherry-pick of #16970) ([#16972](https://github.com/pantsbuild/pants/pull/16972))

* `wait` for killed nailgun processes. (Cherry-pick of #16924) ([#16938](https://github.com/pantsbuild/pants/pull/16938))

* Fix venv re-population race. (Cherry-pick of #16931) ([#16936](https://github.com/pantsbuild/pants/pull/16936))

* Preserve stdio when a local process times out. (Cherry-pick of #16841) ([#16885](https://github.com/pantsbuild/pants/pull/16885))

### Documentation

* Add Thales Menato's proudest contribution (Cherry-pick of #17023) ([#17024](https://github.com/pantsbuild/pants/pull/17024))

* Fix invalid field error message for parametrized fields. (Cherry-pick of #16911) ([#17006](https://github.com/pantsbuild/pants/pull/17006))

* Remove bad linebreaks from python-run-goal page. (Cherry-pick of #16976) ([#16981](https://github.com/pantsbuild/pants/pull/16981))

* Update changelog on docsite with 2.13 links (cherrypick of #16918) ([#16957](https://github.com/pantsbuild/pants/pull/16957))

* Add IBM, Coinbase, and Astranis case studies (Cherry-pick of #16805) ([#16813](https://github.com/pantsbuild/pants/pull/16813))

* fix broken shortlinks that invoked "docs:" instead of "doc:" (Cherry-pick of #16804) ([#16810](https://github.com/pantsbuild/pants/pull/16810))

## 2.13.0 (Sep 7, 2022)

The first stable release of 2.13.0, with no changes since 2.13.0rc3.

See our [blog post](https://blog.pantsbuild.org/introducing-pants-2-13/) for a summary of what's new in Pants 2.13.

## 2.13.0rc3 (Aug 31, 2022)

### Bug fixes

* Make experimental_shell_command deterministic (Cherry-pick of #16675) ([#16699](https://github.com/pantsbuild/pants/pull/16699))

* Ensure the sandbox distdir exists when creating dists via PEP517 (Cherrypick of #16647) ([#16660](https://github.com/pantsbuild/pants/pull/16660))

### Documentation

* Create page of Pants team members and proudest contribs (Cherry-pick of #16676)  ([#16729](https://github.com/pantsbuild/pants/pull/16729))

* Fix example BSP groups file. (Cherry-pick of #16649) ([#16652](https://github.com/pantsbuild/pants/pull/16652))

## 2.13.0rc2 (Aug 24, 2022)

### User API Changes

* Bump default version of `setuptools` to 63.4 ([#16618](https://github.com/pantsbuild/pants/pull/16618))

### Bug fixes

* Have `run` run `__main__.py` for non-zipapp PEXs (Cherry-pick of #16568) ([#16635](https://github.com/pantsbuild/pants/pull/16635))

* Add `grpcio` to default Python module mapping ([#16604](https://github.com/pantsbuild/pants/pull/16604))

* Record `RemoteStoreBlobBytesUploaded` for all upload strategies, rather than only for large blobs. (Cherry-pick of #16545) ([#16555](https://github.com/pantsbuild/pants/pull/16555))

### Performance

* Improve performance of `Owners` rule (Cherry-pick of #16563) ([#16597](https://github.com/pantsbuild/pants/pull/16597))

* Fix performance for generating lockfiles for `pytest` and `setuptools` (Cherry-pick of #16591) ([#16596](https://github.com/pantsbuild/pants/pull/16596))

### Documentation

* Fix `./pants help` docs on command line specs (Cherry-pick of #16616) ([#16623](https://github.com/pantsbuild/pants/pull/16623))

* Use Markdown h3 for ToC support (Cherry-pick of #15964) ([#16558](https://github.com/pantsbuild/pants/pull/16558))

* Fix broken link to community page (Cherry-pick of #16468) ([#16557](https://github.com/pantsbuild/pants/pull/16557))

## 2.13.0rc1 (Aug 12, 2022)

### User API Changes

* Replace `--[no-]process-cleanup` with `--keep-sandboxes={always,never,on_failure}` (Cherry-pick of #16415) ([#16417](https://github.com/pantsbuild/pants/pull/16417))

* Deprecate `[python].tailor_ignore_solitary_init_files` in favor of more useful `[python].tailor_ignore_empty_init_files` (Cherry-pick of #16305) ([#16334](https://github.com/pantsbuild/pants/pull/16334))

* Upgrade Pex to 2.1.102. (Cherry-pick of #16313) ([#16323](https://github.com/pantsbuild/pants/pull/16323))

### Bug fixes

* Add missing `help` message to experimental backends (Cherry-pick of #16403) ([#16500](https://github.com/pantsbuild/pants/pull/16500))

* Fix `CacheContentBehavior::Defer` with a remote cache (Cherry-pick of #16439) ([#16441](https://github.com/pantsbuild/pants/pull/16441))

* Fix docker invalidation bug (cherrypick of #16419) ([#16431](https://github.com/pantsbuild/pants/pull/16431))

* Set immutable_input_digests on a docker RunRequest. (Cherry-pick of #16385) ([#16396](https://github.com/pantsbuild/pants/pull/16396))

* go: pass -p option to `go tool asm` on Go v1.19+ (Cherry pick of #16381) ([#16395](https://github.com/pantsbuild/pants/pull/16395))

* consume inits part of package object within the inner scope (Cherry-pick of #16282) ([#16371](https://github.com/pantsbuild/pants/pull/16371))

* Add a newline at the end of `paths` output (Cherry-pick of #16302) ([#16372](https://github.com/pantsbuild/pants/pull/16372))

* fix kotlin tailor for junit tests (Cherry pick of #16333) ([#16341](https://github.com/pantsbuild/pants/pull/16341))

* Explicitly add directory entries to resources JARs  (Cherry-pick of #16264) ([#16296](https://github.com/pantsbuild/pants/pull/16296))

* Allow using `--import` option with Autoflake (Cherry-pick of #16192) ([#16275](https://github.com/pantsbuild/pants/pull/16275))

* Dont use PEX as an API to fix `ModuleNotFoundError` for `--debug-adapter` (Cherry-pick of #16263) ([#16267](https://github.com/pantsbuild/pants/pull/16267))

### Performance

* Implement a `validate` mode to reduce network usage for remote caches (Cherry-pick of #16398) ([#16409](https://github.com/pantsbuild/pants/pull/16409))

### Documentation

* Update docs on how to run Pants in CI. (Cherry-pick of #16503) ([#16509](https://github.com/pantsbuild/pants/pull/16509))

* Fix partition description for MyPy when multiple resolves (Cherry-pick of #16486) ([#16498](https://github.com/pantsbuild/pants/pull/16498))

* Fix source roots docs. (Cherry-pick of #16363) ([#16365](https://github.com/pantsbuild/pants/pull/16365))

* Link to dev.to post on resource hub (cherrypick #16331) ([#16349](https://github.com/pantsbuild/pants/pull/16349))

* add tailor docs for kotlin backend (Cherry pick of #16332) ([#16338](https://github.com/pantsbuild/pants/pull/16338))

* docs: add initial Kotlin docs (Cherry pick of #16304) ([#16329](https://github.com/pantsbuild/pants/pull/16329))

* Document test sharding and update plugin docs with 2.13 changes (Cherry-pick of #16293) ([#16306](https://github.com/pantsbuild/pants/pull/16306))

## 2.13.0rc0 (Jul 20, 2022)

### New Features

* allow JVM sources to have files dependencies (Cherry-pick of #16203) ([#16236](https://github.com/pantsbuild/pants/pull/16236))

* Add [python].default_run_goal_use_sandbox (Cherry-pick of #16239) ([#16253](https://github.com/pantsbuild/pants/pull/16253))

* Add `include_sources` to `pex_binary` target (Cherry-pick of #16215) ([#16252](https://github.com/pantsbuild/pants/pull/16252))

* Add support for extra env variables in go tests (Cherry-pick of #16013) ([#16067](https://github.com/pantsbuild/pants/pull/16067))

### User API Changes

* Ban `../` in `source` and `sources` fields (Cherry-pick of #16227) ([#16237](https://github.com/pantsbuild/pants/pull/16237))

* Upgrade Pex to 2.1.99. (Cherry-pick of #16184) ([#16225](https://github.com/pantsbuild/pants/pull/16225))

* Correct deprecation warning to 2.15 (Cherry-pick of #16056) ([#16218](https://github.com/pantsbuild/pants/pull/16218))

* Fix poetry locks missing hashes. (Cherry-pick of #16112) ([#16113](https://github.com/pantsbuild/pants/pull/16113))

### Plugin API Changes

* Generically compute dynamic defaults for `Field`s (Cherry-pick of #16206) ([#16219](https://github.com/pantsbuild/pants/pull/16219))

### Bug fixes

* Refactors `output_field` to default to something that disambiguates on paramtrized fields (Cherry-pick of #16232) ([#16254](https://github.com/pantsbuild/pants/pull/16254))

* Apply parameter filling for `parametrize`d dependencies to excludes, and fix accommodation for file-addressed atom targets (Cherry-pick of #16249) ([#16250](https://github.com/pantsbuild/pants/pull/16250))

* Remove removal of use_deprecated_pex_binary_run_semantics in 2.13.x ([#16108](https://github.com/pantsbuild/pants/pull/16108))

* Fix scala plugins args order causing cache issues (Cherry-pick of #16228) ([#16234](https://github.com/pantsbuild/pants/pull/16234))

* Add overrides field to scala targets (Cherry-pick of #16204) ([#16235](https://github.com/pantsbuild/pants/pull/16235))

* Fix explicit dependencies of `parametrize`d targets not working for some target types (#16197) ([#16214](https://github.com/pantsbuild/pants/pull/16214))

* Fill address parameters in all cases, rather than only when a consumer is `parametrize`d. (Cherry-pick of #16198) ([#16210](https://github.com/pantsbuild/pants/pull/16210))

* Use filelists to make archive creation tasks more reliable (Cherry-pick of #16183) ([#16186](https://github.com/pantsbuild/pants/pull/16186))

* Fix defaulting of parameters in explicitly specified deps on `parametrize`d targets for AsyncFieldMixin (Cherry-pick of #16176) ([#16180](https://github.com/pantsbuild/pants/pull/16180))

* Improve memoization of interpreter constraints, Python parsing, and request classes (Cherry-pick of #16141) ([#16154](https://github.com/pantsbuild/pants/pull/16154))

* Add support for `InteractiveProcess` consuming inputs while `run_in_workspace=True` (Cherry-pick of #16093) ([#16148](https://github.com/pantsbuild/pants/pull/16148))

* Optimize `get_expanded_specs` for `StreamingWorkunit` plugins (Cherry-pick of #16106) ([#16147](https://github.com/pantsbuild/pants/pull/16147))

* Record ongoing backtrack attempts (Cherry-pick of #16075) ([#16080](https://github.com/pantsbuild/pants/pull/16080))

* Write to caches during backtracking (Cherry-pick of #16078) ([#16081](https://github.com/pantsbuild/pants/pull/16081))

* Fix `--changed-since` with `tailor` and `update-build-files` when no changes ([#16066](https://github.com/pantsbuild/pants/pull/16066))

* Fix pantsd TTY handling. (Cherry-pick of #16038) ([#16048](https://github.com/pantsbuild/pants/pull/16048))

### Performance

* Port `@rule` `Get`s to rust (Cherry-pick of #16160) ([#16177](https://github.com/pantsbuild/pants/pull/16177))

### Documentation

* Document `--filter` options working with any goal (Cherry-pick of #16090) ([#16209](https://github.com/pantsbuild/pants/pull/16209))

* Document the "fromfile" feature. (cherrypick of #16205) ([#16208](https://github.com/pantsbuild/pants/pull/16208))

* Add 2.12 changelog to docsite (cherrypick #16136) ([#16139](https://github.com/pantsbuild/pants/pull/16139))

* New doc explaining vcs_version. (Cherrypick of #16092) ([#16102](https://github.com/pantsbuild/pants/pull/16102))

* Fix typo in warning for `[python].resolve_all_constraints` (Cherry-pick of #16068) ([#16073](https://github.com/pantsbuild/pants/pull/16073))

* Update docs with 2.12 changes: default Pex lockfile generator, `pants.toml` env var interpolation, pip VCS requirements, and Python interpreter constraints (Cherry-pick of #16000) ([#16058](https://github.com/pantsbuild/pants/pull/16058))

* Fix CI provider table rendering. (cherrypick of #16051) ([#16060](https://github.com/pantsbuild/pants/pull/16060))

* Document Docker registries configuration options for `skip_push` and `extra_image_tags`. (Cherry-pick of #16015) ([#16020](https://github.com/pantsbuild/pants/pull/16020))

## 2.13.0a1 (Jun 29, 2022)

### New Features

* Add ability to `run` any `PythonSourceField` (Cherry-pick of #15849) ([#16022](https://github.com/pantsbuild/pants/pull/16022))

* Add `--debug-adapter` flag to `run` (Cherry-pick of #15829) ([#15988](https://github.com/pantsbuild/pants/pull/15988))

* Add repository config option to Docker registries. (Cherry pick of #15884) ([#15952](https://github.com/pantsbuild/pants/pull/15952))

### User API Changes

* Deprecate not setting `tailor_pex_binary_targets` explictly (Cherry-pick of #15962) ([#16023](https://github.com/pantsbuild/pants/pull/16023))

* Upgrade default iPython to 7.34, which drops Python 3.6 (Cherry-pick of #15934) ([#15938](https://github.com/pantsbuild/pants/pull/15938))

### Plugin API Changes

* Introduce a plugin API to provide all thread local state, and deprecate stdio-specific methods (Cherry-pick of #15890) ([#15916](https://github.com/pantsbuild/pants/pull/15916))

### Bug fixes

* Backtrack through calls from `@rules` to synchronous engine methods (Cherry-pick of #15979) ([#16001](https://github.com/pantsbuild/pants/pull/16001))

* Assorted remote metrics fixes. (Cherry-pick of #15914) ([#15976](https://github.com/pantsbuild/pants/pull/15976))

* Fix bad "<infallible>" description in invalid addresses error messages (Cherry-pick of #15859) ([#15936](https://github.com/pantsbuild/pants/pull/15936))

* Fix reporting of time spent downloading files (Cherry-pick of #15873) ([#15921](https://github.com/pantsbuild/pants/pull/15921))

* Upgrade to `nails` `0.13.0` to pick up support for `JDK >=13`. (Cherry-pick of #15899) ([#15918](https://github.com/pantsbuild/pants/pull/15918))

* Allow JVM memory controls to bound the process pool size to less than the process parallelism (Cherry-pick of #15903) ([#15917](https://github.com/pantsbuild/pants/pull/15917))

* Increment the missing-digest backtracking level once per attempt (Cherry pick of #15889) ([#15897](https://github.com/pantsbuild/pants/pull/15897))

* Scala: should visit ctor args of base type (Cherry pick of #15880) ([#15892](https://github.com/pantsbuild/pants/pull/15892))

* Scala: mark an object that extends another type as recursive (Cherry pick of #15865) ([#15891](https://github.com/pantsbuild/pants/pull/15891))

### Performance

* terraform: use immutable input for Terraform tool (Cherry-pick of #15037) ([#15998](https://github.com/pantsbuild/pants/pull/15998))

* Improve performance of file arguments when `--owners-not-found-behavior` not used ([#15931](https://github.com/pantsbuild/pants/pull/15931))

* Dedupe `load_bytes_with` calls to a remote Store (Cherry-pick of #15901) ([#15915](https://github.com/pantsbuild/pants/pull/15915))

### Documentation

* Update Python documentation with 2.11 changes (Cherry-pick of #15857) ([#15981](https://github.com/pantsbuild/pants/pull/15981))

* Update certificate environment variable advice for #14808. (Cherry-pick of #15943) ([#15974](https://github.com/pantsbuild/pants/pull/15974))

* Update the docs for `fmt` and test report changes (Cherry-pick of #15968) ([#15971](https://github.com/pantsbuild/pants/pull/15971))

* Clarify deprecation messages for `tailor` and `update-build-files` requiring CLI arguments (Cherry-pick of #15932) ([#15937](https://github.com/pantsbuild/pants/pull/15937))

## 2.13.0a0 (Jun 17, 2022)

### New Features

* Add option for max wait before terminating interactive process ([#15767](https://github.com/pantsbuild/pants/pull/15767))

### User API Changes

* Add `[scala-infer].force_add_siblings_as_dependencies` and deprecate it defaulting to true ([#15841](https://github.com/pantsbuild/pants/pull/15841))

* Add `--debug-adapter` flag to `test` goal ([#15799](https://github.com/pantsbuild/pants/pull/15799))

### Plugin API Changes

* Add `skip_invalid_addresses` field to `UnparsedAddressInputs` ([#15864](https://github.com/pantsbuild/pants/pull/15864))

* Add `MaybeAddress` for infallible evaluation of `AddressInput` ([#15863](https://github.com/pantsbuild/pants/pull/15863))

* Add optional `StringSequenceField.valid_choices` ([#15684](https://github.com/pantsbuild/pants/pull/15684))

* `WrappedTarget` now requires `WrappedTargetRequest` ([#15789](https://github.com/pantsbuild/pants/pull/15789))

* Move `ResolveError` from `pants.base.exceptions` to `pants.build_graph.address` ([#15790](https://github.com/pantsbuild/pants/pull/15790))

* `_TargetParametrizations` now requires `_TargetParametrizationsRequest` ([#15759](https://github.com/pantsbuild/pants/pull/15759))

* `BuildFileAddress` now requires `BuildFileAddressRequest` ([#15760](https://github.com/pantsbuild/pants/pull/15760))

### Bug fixes

* Support `--help` for builtin goals. ([#15798](https://github.com/pantsbuild/pants/pull/15798))

* Handle venv path special chars in coursier fetch ([#15701](https://github.com/pantsbuild/pants/pull/15701))

* Fix `[python-infer].inits` and `[python-infer].conftests` to consider `resolve` field ([#15787](https://github.com/pantsbuild/pants/pull/15787))

### Performance

* Backtrack execution for missing digests to make `eager_fetch=false` more resilient ([#15850](https://github.com/pantsbuild/pants/pull/15850))

* Remove synchronous remote cache lookup from remote execution ([#15854](https://github.com/pantsbuild/pants/pull/15854))

### Documentation

* Fix broken links to `tailor` documentation ([#15842](https://github.com/pantsbuild/pants/pull/15842))

* Update docs for redesign of CLI arguments ([#15816](https://github.com/pantsbuild/pants/pull/15816))

* Better error message when an address does not exist ([#15788](https://github.com/pantsbuild/pants/pull/15788))

## 2.13.0.dev5 (Jun 08, 2022)

### New Features

* Add GraphQL API server backend for the experimental-explorer goal ([#15697](https://github.com/pantsbuild/pants/pull/15697))

* Add `extra_env_vars` field to `experimental_shell_command` target. ([#15742](https://github.com/pantsbuild/pants/pull/15742))

* Add `experimental-explorer` builtin goal. ([#15695](https://github.com/pantsbuild/pants/pull/15695))

### User API Changes

* Always ignore paths which are not files, directories, or links. ([#15773](https://github.com/pantsbuild/pants/pull/15773))

* Add API types and rules to cli help info ([#14227](https://github.com/pantsbuild/pants/pull/14227))

* Change the default `remote_cache_warnings` warnings behavior to `backoff`. ([#15745](https://github.com/pantsbuild/pants/pull/15745))

* Revert "Go can use both `file` and `resource` targets (#15663)" ([#15725](https://github.com/pantsbuild/pants/pull/15725))

* Deprecate `--exclude-target-regexp` in favor of `--filter-address-regex` ([#15729](https://github.com/pantsbuild/pants/pull/15729))

### Plugin API Changes

* Require setting `description_of_origin` with `AddressInput` and `UnparsedAddressInputs` ([#15743](https://github.com/pantsbuild/pants/pull/15743))

* Require keyword arguments for `AddressInput` ([#15741](https://github.com/pantsbuild/pants/pull/15741))

### Bug fixes

* `tailor` should skip bad requirements targets ([#15755](https://github.com/pantsbuild/pants/pull/15755))

* `tailor` for Go does not add targets when no ancestor `go.mod` ([#15750](https://github.com/pantsbuild/pants/pull/15750))

* Record metrics for remote cache store errors ([#15744](https://github.com/pantsbuild/pants/pull/15744))

* Fix help for `--process-total-child-memory-usage` and `--process-per-child-memory-usage` ([#15733](https://github.com/pantsbuild/pants/pull/15733))

* Fix `--changed-since` with directories unknown to Pants ([#15714](https://github.com/pantsbuild/pants/pull/15714))

### Documentation

* Improve error messages for invalid addresses ([#15751](https://github.com/pantsbuild/pants/pull/15751))

* Correctly describe the origin of invalid specs, e.g. `--paths-from` ([#15730](https://github.com/pantsbuild/pants/pull/15730))

## 2.13.0.dev4 (May 31, 2022)

### New Features

* Support running pex_binary targets directly on the in-repo sources. ([#15689](https://github.com/pantsbuild/pants/pull/15689))

* Go can use both `file` and `resource` targets ([#15663](https://github.com/pantsbuild/pants/pull/15663))

* Add ignore command line arguments, e.g. `-dir::` ([#15619](https://github.com/pantsbuild/pants/pull/15619))

* Allow to skip linting on Helm charts ([#15640](https://github.com/pantsbuild/pants/pull/15640))

* Helm charts support CRDS by default ([#15623](https://github.com/pantsbuild/pants/pull/15623))

* Adds dependency injection rule for protobuf-java runtime ([#15006](https://github.com/pantsbuild/pants/pull/15006))

### User API Changes

* Make the global --no-process-cleanup conserve the `run` tmpdir. ([#15683](https://github.com/pantsbuild/pants/pull/15683))

* Upgrade Pex to 2.1.90. ([#15656](https://github.com/pantsbuild/pants/pull/15656))

* Remove `-d` as shorthand for `--logdir` ([#15621](https://github.com/pantsbuild/pants/pull/15621))

### Plugin API Changes

* `PutativeTargetsRequest.path_globs()` can take multiple globs ([#15634](https://github.com/pantsbuild/pants/pull/15634))

* [Plugin API change] Remove default help message from MultipleSourcesField ([#15633](https://github.com/pantsbuild/pants/pull/15633))

* Don't allow multiple flag names for the same option ([#15627](https://github.com/pantsbuild/pants/pull/15627))

* Remove `PutativeTargetsSearchPaths` ([#15625](https://github.com/pantsbuild/pants/pull/15625))

* Refactor `Specs` as prework for ignore Specs ([#15620](https://github.com/pantsbuild/pants/pull/15620))

* Ban using short option names like `-x`, except for pre-blessed values ([#15624](https://github.com/pantsbuild/pants/pull/15624))

### Bug fixes

* Don't install Pex-style lockfile when no requirements used ([#15706](https://github.com/pantsbuild/pants/pull/15706))

* `python_requirements()` can handle `-r reqs.txt` ([#15672](https://github.com/pantsbuild/pants/pull/15672))

* Increase RuleGraph solver loop threshold to allow for larger `@rule` sets ([#15668](https://github.com/pantsbuild/pants/pull/15668))

* Fix `--help` output when specs given. ([#15665](https://github.com/pantsbuild/pants/pull/15665))

* `update-build-files` falls back to interpreter constraints from tool lockfile for Black and Yapf ([#15666](https://github.com/pantsbuild/pants/pull/15666))

* Fix detection of `--help` when specs given ([#15664](https://github.com/pantsbuild/pants/pull/15664))

* Choose correct Scala dialect according to scala-version ([#15649](https://github.com/pantsbuild/pants/pull/15649))

* Fix deleted files with `--changed-since` when using target-less goals like `count-loc` ([#15662](https://github.com/pantsbuild/pants/pull/15662))

* Prevent collisions between attempts to materialize an immutable input digest. ([#15652](https://github.com/pantsbuild/pants/pull/15652))

* Fix another case of direct Coursier lockfile consumption ([#15650](https://github.com/pantsbuild/pants/pull/15650))

### Documentation

* Mention language specific opt outs for `tailor` ([#15673](https://github.com/pantsbuild/pants/pull/15673))

* Provide more "Did you mean ..." suggestions for the CLI help. ([#15646](https://github.com/pantsbuild/pants/pull/15646))

* [docs] Add language specific file examples for sources help message of a target ([#15635](https://github.com/pantsbuild/pants/pull/15635))

* Docs: show language specific file examples in sources field in the help of targets ([#15595](https://github.com/pantsbuild/pants/pull/15595))

## 2.13.0.dev3 (May 23, 2022)

### New Features

* `dir:` and `dir::` work on target-less goals like `count-loc` ([#15577](https://github.com/pantsbuild/pants/pull/15577))

* `--changed-since` works on target-less goals like `count-loc` ([#14434](https://github.com/pantsbuild/pants/pull/14434))

* Add `--no-use-deprecated-directory-cli-args-semantics` so that directory arguments match all files/targets in the directory ([#15589](https://github.com/pantsbuild/pants/pull/15589))

* `filter` options work with any goal now, not only the `filter` goal ([#15599](https://github.com/pantsbuild/pants/pull/15599))

* Use new, consistent CLI args semantics for `tailor` if `use_deprecated_cli_args_semantics = false` ([#15612](https://github.com/pantsbuild/pants/pull/15612))

* Support JVM options per tool ([#15505](https://github.com/pantsbuild/pants/pull/15505))

* Allow turning off `export` of Python tools like `black` ([#15509](https://github.com/pantsbuild/pants/pull/15509))

* Adding file downloading support to asset targets ([#15457](https://github.com/pantsbuild/pants/pull/15457))

### User API Changes

* Deprecate `filter` goal now that `filter` options can be used from any goal ([#15600](https://github.com/pantsbuild/pants/pull/15600))

* Tailor `__main__.py` files as pex binaries ([#15598](https://github.com/pantsbuild/pants/pull/15598))

* `update-build-files` now takes CLI args for which BUILD files to change ([#15581](https://github.com/pantsbuild/pants/pull/15581))

* Don't error when `dir:` and `dir::` have no targets, as long as the directories exist ([#15570](https://github.com/pantsbuild/pants/pull/15570))

* Deprecate `--owners-not-found-behavior` and set default to `ignore` ([#15560](https://github.com/pantsbuild/pants/pull/15560))

* Add `--unmatched-cli-globs`, which before was controlled by `--owners-not-found-behavior` ([#15556](https://github.com/pantsbuild/pants/pull/15556))

* Deprecate `files_not_found_behavior` in favor of `unmatched_build_file_globs` ([#15555](https://github.com/pantsbuild/pants/pull/15555))

* Remove undocumented CLI file arguments ignore syntax ([#15534](https://github.com/pantsbuild/pants/pull/15534))

* `go_third_party_package` targets now depend on their `go.mod` and `go.sum` ([#15521](https://github.com/pantsbuild/pants/pull/15521))

* `--changed-dependees` no longer runs on sibling targets from same target generator ([#15396](https://github.com/pantsbuild/pants/pull/15396))

* Change `_generator_sources_helper` to use `source: str` rather than `sources: list[str]` ([#15475](https://github.com/pantsbuild/pants/pull/15475))

* Upgrade Pex to 2.1.88. ([#15484](https://github.com/pantsbuild/pants/pull/15484))

* Revert "Deprecate `[python].tailor_ignore_solitary_init_files` in favor of more useful `[python].tailor_ignore_empty_init_files` (#15469)" ([#15492](https://github.com/pantsbuild/pants/pull/15492))

### Plugin API Changes

* Replace `SpecsSnapshot` with lazier `SpecsPaths` ([#15593](https://github.com/pantsbuild/pants/pull/15593))

* Rename classes in `specs.py` for unification of specs semantics ([#15538](https://github.com/pantsbuild/pants/pull/15538))

* Remove `addressable=` kwarg from `tailor` ([#15504](https://github.com/pantsbuild/pants/pull/15504))

* Remove `AbstractTestGenerator` from `pantsbuild.pants.testutil` ([#15464](https://github.com/pantsbuild/pants/pull/15464))

### Bug fixes

* Fix incorrect digest for JVM multiple `jvm_artifact(.., jar=..)` entries ([#15571](https://github.com/pantsbuild/pants/pull/15571))

* Record Scala `package object` as provided name ([#15582](https://github.com/pantsbuild/pants/pull/15582))

* Fix deprecation message for `--filter-target-type` with deprecated target alias ([#15596](https://github.com/pantsbuild/pants/pull/15596))

* Fix scala inference doesn't infer name after function call ([#15565](https://github.com/pantsbuild/pants/pull/15565))

* Fix JVM resource classification and artifact grouping ([#15567](https://github.com/pantsbuild/pants/pull/15567))

* Apply `--tag` filtering to target-less goals like `count-loc` ([#15479](https://github.com/pantsbuild/pants/pull/15479))

* Fix `tag` filtering with `--changed-dependees` ([#15546](https://github.com/pantsbuild/pants/pull/15546))

* Fix non-deterministic order of `jvm_artifact(.., excludes=..)` ([#15542](https://github.com/pantsbuild/pants/pull/15542))

* Support transitive file dependencies in Scalatest/JUnit ([#15501](https://github.com/pantsbuild/pants/pull/15501))

* Improve `name=` used for Python requirement target generators with `tailor` ([#15507](https://github.com/pantsbuild/pants/pull/15507))

* don't generate default tool lockfiles ([#15488](https://github.com/pantsbuild/pants/pull/15488))

* Don't give a subsequent formatter an empty snapshot after skipping ([#15483](https://github.com/pantsbuild/pants/pull/15483))

* jvm: fix incorrect check for root-only `ClasspathEntryRequest` implementations ([#15494](https://github.com/pantsbuild/pants/pull/15494))

### Performance

* `lint` only finds targets and files if the relevant linters were specified ([#15579](https://github.com/pantsbuild/pants/pull/15579))

* `regex-lint` only reads files that will be checked ([#15580](https://github.com/pantsbuild/pants/pull/15580))

### Documentation

* Freshen up deprecated option formatting ([#15590](https://github.com/pantsbuild/pants/pull/15590))

* Make required fields sort first on the docsite and in the './pants help target' output ([#15587](https://github.com/pantsbuild/pants/pull/15587))

* Add a few default_help_reprs ([#15588](https://github.com/pantsbuild/pants/pull/15588))

* Suggest a UUID when erroring about missing UUID ([#15550](https://github.com/pantsbuild/pants/pull/15550))

* Tweak docs to include `no-infer-dep` in a few more places ([#15547](https://github.com/pantsbuild/pants/pull/15547))

## 2.13.0.dev2 (May 14, 2022)

### New Features

* Adds JDK autoconfiguration support to scala BSP metadata setup  ([#15408](https://github.com/pantsbuild/pants/pull/15408))

* Add `lint --skip-formatters` option ([#15427](https://github.com/pantsbuild/pants/pull/15427))

* Support for sharding tests. ([#15417](https://github.com/pantsbuild/pants/pull/15417))

* Add clang-format support for the experimental c/cpp plugin ([#15395](https://github.com/pantsbuild/pants/pull/15395))

* Support setting env vars in individual distribution builds. ([#15422](https://github.com/pantsbuild/pants/pull/15422))

* kotlin: add support for junit tests ([#15382](https://github.com/pantsbuild/pants/pull/15382))

### User API Changes

* Upgrade Pex to 2.1.87. ([#15472](https://github.com/pantsbuild/pants/pull/15472))

* Deprecate `[python].tailor_ignore_solitary_init_files` in favor of more useful `[python].tailor_ignore_empty_init_files` ([#15469](https://github.com/pantsbuild/pants/pull/15469))

* Upgrade default Protoc version to 3.20.1 (native Apple Silicon support) ([#15424](https://github.com/pantsbuild/pants/pull/15424))

* Require that a target's `interpreter_constraints` are a subset of their dependencies' ([#15373](https://github.com/pantsbuild/pants/pull/15373))

* Add `[python-infer].init_files` as more intuitive replacement for `[python-infer].inits` ([#15397](https://github.com/pantsbuild/pants/pull/15397))

### Plugin API Changes

* Move `get_git` deprecation to start in `2.14.0.dev0` ([#15423](https://github.com/pantsbuild/pants/pull/15423))

### Bug fixes

* Only infer an __init__.py dep on a python_sources-generated target. ([#15471](https://github.com/pantsbuild/pants/pull/15471))

* kotlin: the `plugin_id` field on `kotlinc_plugin` target is optional ([#15459](https://github.com/pantsbuild/pants/pull/15459))

* support relative address syntax for JVM compiler plugin artifacts ([#15462](https://github.com/pantsbuild/pants/pull/15462))

* Fix lockfile generation for Docker, Terraform, and Clang-format to not require Python backend ([#15453](https://github.com/pantsbuild/pants/pull/15453))

* Fix boolean logic when merging interpreter constraints. ([#15414](https://github.com/pantsbuild/pants/pull/15414))

* Fix `tags` to work with filesystem arguments, `overrides` field, and `python_tests` ([#15394](https://github.com/pantsbuild/pants/pull/15394))

* Support the `{chroot}` env placeholder for all interactive processes that are not executed in the workspace. ([#15401](https://github.com/pantsbuild/pants/pull/15401))

* Fix `[]` in file names with target generators ([#15383](https://github.com/pantsbuild/pants/pull/15383))

* BSP consumes thirdparty artifacts via their classpath entries, rather than directly from the lockfile. ([#15392](https://github.com/pantsbuild/pants/pull/15392))

### Documentation

* Improve error message for `dependencies` on incompatible Python resolves ([#15416](https://github.com/pantsbuild/pants/pull/15416))

## 2.13.0.dev1 (May 10, 2022)

### New Features

* Initial support for building dists using mypyc. ([#15380](https://github.com/pantsbuild/pants/pull/15380))

* Support dependency inference on vcs_version targets. ([#15385](https://github.com/pantsbuild/pants/pull/15385))

* Support for getting a version string from git. ([#15374](https://github.com/pantsbuild/pants/pull/15374))

* Add `tailor` for `poetry_requirements` and `pipenv_requirements` ([#15352](https://github.com/pantsbuild/pants/pull/15352))

### User API Changes

* Add default mapping for pygithub ([#15361](https://github.com/pantsbuild/pants/pull/15361))

### Bug fixes

* Generalize Docker dep inference for all packageables. ([#15375](https://github.com/pantsbuild/pants/pull/15375))

* Fix `tailor` detection of existing `python_requirements` targets ([#15363](https://github.com/pantsbuild/pants/pull/15363))

* Add the "named args explanation" to other relevant `parametrize` error messages. ([#15362](https://github.com/pantsbuild/pants/pull/15362))

* Use abspath to sandbox in PATH for docker tool shims. ([#15341](https://github.com/pantsbuild/pants/pull/15341))

### Documentation

* Improve `help` and error message for `[python-infer].unowned_dependency_behavior` ([#15334](https://github.com/pantsbuild/pants/pull/15334))

* Disallow `!` patterns in `build_ignore`. ([#15366](https://github.com/pantsbuild/pants/pull/15366))

## 2.13.0.dev0 (May 05, 2022)

### New Features

* BSP compile exposes loose classfiles to allow IntelliJ to invoke tests ([#15347](https://github.com/pantsbuild/pants/pull/15347))

* Add options to turn off `tailor` on a per-language basis ([#15335](https://github.com/pantsbuild/pants/pull/15335))

### User API Changes

* Upgrade hadolint to 2.10.0 and add linux arm64 support ([#15317](https://github.com/pantsbuild/pants/pull/15317))

* Remove `[test].xml_dir`, `[update-build-files].fix_python_macros`, and `[java-infer].third_party_imports` ([#15311](https://github.com/pantsbuild/pants/pull/15311))

* Deprecate `[golang].expected_version` in favor of more flexible `[golang].minimum_expected_version` ([#15306](https://github.com/pantsbuild/pants/pull/15306))

### Plugin API Changes

* Add `update_env` to `process_execution::local`. ([#15340](https://github.com/pantsbuild/pants/pull/15340))

### Bug fixes

* Fix error output of `parametrize()` ([#15339](https://github.com/pantsbuild/pants/pull/15339))

* Don't strip source roots when building dists with an existing setup.py ([#15303](https://github.com/pantsbuild/pants/pull/15303))

* Fix a bug in the python venv export logic. ([#15294](https://github.com/pantsbuild/pants/pull/15294))

* Fix non-determinism of `package_data` in generated `setup.py` files ([#15292](https://github.com/pantsbuild/pants/pull/15292))

### Performance

* Eagerly skip tools with default lockfiles in `export-lockfiles` goal ([#15304](https://github.com/pantsbuild/pants/pull/15304))

### Documentation

* Improve error message for resolves x interpreter constraints issues ([#15314](https://github.com/pantsbuild/pants/pull/15314))
